<?php
/**
 * This file Updates Shipment against Orders
 *
 * @package Joovii Auspost Shipping Plugin
 *
 * @link https://joovii.com
 *
 * PHP version : 7.2.1
 */


function jooviiauspost_update_settings($params)
{
	$inputs = [];

	if( isset($_REQUEST) && is_array($_REQUEST) )
	{
		foreach($_REQUEST as $key=>$value)
		{
		   	$inputs[$key] = sanitize_text_field($value);
		}
	}
	
	if (count($inputs)) {
		$st = maybe_unserialize(get_option('woocommerce_jooviiauspost_settings'));
		if (is_array($st) && count($st) ) {
			if (isset($st['accesstoken']) && ''!=$st['accesstoken']) {
				// All Good, Just Update the settings
				if (isset($inputs['settings']) && is_array($inputs['settings'])) {
					$result_arr = array_merge($st, $inputs['settings']);
					$r = update_option('woocommerce_jooviiauspost_settings', $result_arr);
					if ($r) {
						return JooviiAuspost_re('Settings Updated Successfully');
					} else {
						return JooviiAuspost_rs('Settings Updation Failed');
					}
				}

			} else {
				return JooviiAuspost_re('Access Token Missing in Woo Store');
			}

		} else {
			return JooviiAuspost_re('Access Token Missing in Woo Store');
		}
	}
}

/**
 * This function shows Error messages
 * as API response and ends the execution
 *
 * @param String $msg : Input Message
 *
 * @return void
 */
function JooviiAuspost_re($msg) {
	return wp_json_encode(['err' => 1, 'msg' => $msg]);
}
/**
 * This function shows Success messages
 * as API response and ends the execution
 *
 * @param String $msg : Input Message
 *
 * @return void
 */
function JooviiAuspost_rs($msg) {
	return wp_json_encode(['err' => 0, 'msg' => $msg]);
}
