<?php
if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly
//add_action( 'load-post.php', 'JooviiAuspost_meta_boxes_setup' );
//add_action( 'load-post-new.php', 'JooviiAuspost_meta_boxes_setup' );
add_action( 'add_meta_boxes', 'JooviiAuspost_meta_boxes' );

function JooviiAuspost_meta_boxes_setup() {
	//$jooviiAuspost_setting = maybe_unserialize( get_option('woocommerce_jooviiauspost_settings') );
	add_action( 'add_meta_boxes', 'JooviiAuspost_meta_boxes' );
}
function JooviiAuspost_meta_boxes() {
	//if (JooviiAuspost_getAssignPermission()) {
		add_meta_box( 'woocommerce-jooviiAuspost-track-shipment', __( 'Joovii Auspost Shipment', 'joovii-auspost-shipping-method' ), 'JooviiAuspost_shipment_options', 'woocommerce_page_wc-orders', 'side', 'high' );
	//}
}

function JooviiAuspost_shipment_options($order) {
	global $woocommerce, $post;
	//$order = new WC_Order($post->ID);
	//$order_number = trim(str_replace('#', '', $order->get_order_number()));
	//$order_id = trim($order->ID);
	$order_id = $order->get_id();
	
	if( JooviiAuspost_check_if_hpos_enabled() )
	{
		$jooviiAuspost_reference  = $order->get_meta('jooviiauspost_reference');
		$jooviiAuspost_order_id   = $order->get_meta('jooviiauspost_order_id');
		$jooviiAuspost_response   = $order->get_meta('jooviiauspost_response');
		$jooviiAuspost_label_url  = $order->get_meta('jooviiauspost_label_url');
	}
	else 
	{
		$jooviiAuspost_reference = get_post_meta($order_id, 'jooviiauspost_reference', true);
		$jooviiAuspost_order_id  = get_post_meta($order_id, 'jooviiauspost_order_id', true);
		$jooviiAuspost_response  = get_post_meta($order_id, 'jooviiauspost_response', true);
		$jooviiAuspost_label_url = get_post_meta($order_id, 'jooviiauspost_label_url', true);
	}
	$jooviiAuspost_setting = maybe_unserialize( get_option('woocommerce_jooviiauspost_settings') );
	$show_popup = 1;
	$shopid  = isset($jooviiAuspost_setting['shop_id']) ? $jooviiAuspost_setting['shop_id'] : '';
	$securitycode = isset($jooviiAuspost_setting['accesstoken']) ? $jooviiAuspost_setting['accesstoken'] : '';
	$target_url = JOOVIIAUSPOST_WEBAPP_URL . '/shopadmin/oms/orderdetails_new?orderid=' . $order_id . '&mode=normal&refrshcache=no&shopid=' . $shopid . '&securitycode=' . $securitycode ;
	
	echo '<ul>';
	if ('' == $jooviiAuspost_reference) {
?>
		<li><a class='shipmentSubmitModal' href="#popup1" onclick="jooviiauspost_setIframe('<?php echo esc_url($target_url);?>')" style="pointer:cursor"><?php echo esc_html('View AusPost Shipment Option'); ?></a></li>
<?php
	}
	
	if ('x' == $jooviiAuspost_reference) {
		$labelsArray = JooviiAuspost_getDownloadLabelLink($jooviiAuspost_order_id);
		foreach ($labelsArray as $kl=>$vl) { 
?>
			<li>
				<a href="<?php echo esc_url(admin_url('admin.php?page=download-shipping-label&oid=' . $order_id . '&pdfdlink=' . $vl['size'] )); ?>" target="_blank">
				<?php echo esc_html('Download Shipping Label[size=' . $vl['size'] . ']' ); ?>
				</a>
			</li>
<?php 
		} 

?>
		<li><a class='shipmentSubmitModal' href="#popup1" onclick="setIframe('<?php echo esc_url($target_url);?>')" style="pointer:cursor"><?php echo esc_html('View Shipment Details'); ?></a></li>
<?php 
	} 
	
	if('' != $jooviiAuspost_label_url) {
?>	
		<li>Shipment has been booked
		<br/>
		<a target='_blank' href='<?php echo esc_url($jooviiAuspost_label_url);?>'>Download Label</a>
		</li>
<?php 	
	}
	echo '</ul>';
	if ( 1== $show_popup ) {	
?>
<div id="popup1" class="jooviiAuspostOverlay">
  <div class="jooviiAuspostPopup">
	<h2>View Quote and Book Shipment</h2>
	<a class="close" href="#">&times;</a>
	<div class="content">
		<iframe id='quoteframe' src=""></iframe>
	</div>
  </div>
</div>

<?php 

	}
}
