<?php
if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

if (!class_exists('WP_List_Table') ) {
		require_once(ABSPATH . 'wp-admin/includes/class-wp-list-table.php');
}

if ( !class_exists('JooviiAuspost_Loader_WP_List_Table' ) ) {
	class JooviiAuspost_Loader_WP_List_Table {
		/**
		* Start up
		*/
		public function __construct() {
			add_action('admin_menu', array($this, 'JooviiAuspost_logs_menu'));
		}

		public function JooviiAuspost_logs_menu() {
			$jooviiAuspost_setting = maybe_unserialize(get_option('woocommerce_jooviiauspost_settings'));
			if ( isset($jooviiAuspost_setting['enable_log']) && 'yes' == $jooviiAuspost_setting['enable_log']) {
				// add submenu items
				
				add_submenu_page('', esc_attr__('JooviiAuspost Logs Table', 'joovii-auspost-shipping-method'), esc_html__('Joovii Logs', 'joovii-auspost-shipping-method'), 'manage_options', 'JooviiAuspost_logs', array($this, 'JooviiAuspost_logs'), 4);
				
			}
		}

		/**
		* Admin page callback
		*/
		public function JooviiAuspost_logs() {
			global $wpdb, $url;
			$logs_table = new JooviiAuspost_Logs_Table();
			$logs_table->prepare_items();
			$url = admin_url('admin.php');
			$jooviiAuspost_logs_str ='';
			$logs_get = ( isset( $_GET['logs'] ) ? sanitize_text_field( wp_unslash($_GET['logs'])) : '' );
			if ( '' != $logs_get ) {
				if ( 'flush' == $logs_get ) {
					$jooviiAuspost_logs_str = 'All Logs have been deleted successfully.';
				}
			}
			?>
	<div class="wrap">
		<?php
		if( $jooviiAuspost_logs_str != "" )
		{	
		   echo '<span class="logclearSuccess">'; 
		   echo esc_html($jooviiAuspost_logs_str);
		   echo '</span>';
		}
		?>
		<br>
		<button class="flush" id="flush" onclick="javascript:jooviiauspost_flush_logs('<?php echo esc_url($url);?>?page=JooviiAuspost_logs&logs=flush');" >Flush Logs</button>
	</div>
	<div class="wrap">
		<h2>All JooviiAuspost Logs</h2>
	</div>	
			<?php
			$logs_table->display();
		}
	}
}

$JooviiAuspost_Loader_WP_List_Table = new JooviiAuspost_Loader_WP_List_Table();
