<?php
if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

if( is_admin() )
{
  //EnQueue Local Scripts
  wp_enqueue_script( 'jooviiauspost_admin_scripts', plugin_dir_url( __FILE__ ) . 'joovii-auspost-admin-scripts.js', array(), '1.0.0', array('strategy'  => 'defer') );
  wp_enqueue_style( 'jooviiauspost_admin_styles', plugin_dir_url( __FILE__ ) . 'joovii-auspost-admin-styles.css' );
}

if ( isset($_REQUEST['logs'] ) ) {

	if ( 'flush' == $_REQUEST['logs'] ) {
		global $wpdb, $url;
		
		$wpdb->query('TRUNCATE TABLE ' . $wpdb->prefix . 'jooviiauspost_logs');
		
		$url = admin_url('admin.php?page=JooviiAuspost_logs&logs=success');
		
		wp_add_inline_script( 'jooviiauspost_admin_scripts', "jooviiauspost_goto_url('$url');" );
		
	}
}

class JooviiAuspost_Logs_Table extends WP_List_Table {
	public function __construct() {
		parent::__construct(array('ajax'=>false));       //does this table support ajax?
	}
	/**
	* Add columns to grid view
	*/
	public function get_columns() {
		$columns = array(
			'id'=>'ID',
			//'eventname'=>'Event Name',
			//'orderid'=>'Order Id',
			'logs'=>'Logs',
			'timestamp'=>'Time'
		);
		return $columns;
	}
	public function column_default($item, $column_name) {
		switch ( $column_name ) {
			case 'id':
			//case 'eventname':
			//case 'orderid':
			case 'logs':
			case 'timestamp':
				return $item[$column_name];
			default:
				return print_r( $item, true ) ; //Show the whole array for troubleshooting purposes
		}
	}
	/**
	* Prepare admin view
	*/
	public function prepare_items() {
		global $wpdb;
		$table_name = $wpdb->prefix . 'jooviiauspost_logs';
		$per_page = 50;
		$current_page = $this->get_pagenum();
		if (1 < $current_page) {
			$offset = $per_page * ( $current_page-1 );
		} else {
			$offset = 0;
		}

		$srcCon = ' AND 2=2 ';

		$req1 = isset($_GET['q1']) &&
				'' != $_GET['q1'] ?
				sanitize_text_field(wp_unslash($_GET['q1']))  :
				'';

		if ('' != $req1) {
			$srcCon .= ' AND logs like \'%' . trim($req1) . '%\' ';
		}

		$req2 = isset($_GET['q2']) &&
				'' != $_GET['q2'] ?
				sanitize_text_field(wp_unslash($_GET['q2'])) :
				'';

		if ('' != $req2) {
			$srcCon .= ' AND logs like \'%' . trim($req2) . '%\' ';
		}

		$items = $wpdb->get_results(
			$wpdb->prepare(
			'SELECT id, CONCAT(\'<pre>\',logs,\'</pre>\') as logs, timestamp FROM %1s WHERE 1=1 %1s ORDER BY id DESC LIMIT %d OFFSET %d;', $table_name, $srcCon, $per_page, $offset),
			ARRAY_A
		);

		$columns = $this->get_columns();

		$this->_column_headers = array($columns);

		$count = $wpdb->get_var(
			$wpdb->prepare('SELECT COUNT(id) FROM %1s WHERE 1=1 %1s ', $table_name, $srcCon)
		);

		$this->items = $items;
		// Set the pagination
		$this->set_pagination_args(array('total_items'=>$count,'per_page'=>$per_page,'total_pages'=>ceil($count/$per_page)));
	}
}
