<?php
if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

add_filter( 'woocommerce_shipping_methods', 'JooviiAuspost_add_shipping_zone_method' );
add_filter( 'woocommerce_shipping_calculator_enable_city', '__return_true'  );
add_action( 'woocommerce_shipping_init', 'JooviiAuspost_Shipping_Zone_Method' );

add_action( 'in_admin_footer', 'JooviiAuspost_my_custom_js_one' );
add_action( 'wp_enqueue_scripts', 'JooviiAuspost_theme_enqueue_scripts' );
add_action( 'wp_footer', 'JooviiAuspost_theme_autocomplete_js' );
add_action ( 'wp_ajax_nopriv_auspostjooviicityziplookup', 'JooviiAuspost_getcityziplookup' );
add_action ( 'wp_ajax_auspostjooviicityziplookup', 'JooviiAuspost_getcityziplookup' );

function JooviiAuspost_my_custom_js_one($hook) {
	/*
	$srt = '<scr ipt type="text/javascript">
	jQuery(\'#woocommerce_auspost_process_as_sendle_order\').css(\'height\',\'90px\');
	</scr ipt> ';
	echo esc_html( $srt );
	*/
}

function JooviiAuspost_theme_enqueue_scripts() {
	$jooviiAuspost_setting  = 	maybe_unserialize( get_option('woocommerce_jooviiauspost_settings') );
	if ( isset($jooviiAuspost_setting['enable_addressmatch']) && 'yes' == $jooviiAuspost_setting['enable_addressmatch'] ) {
		wp_enqueue_script( 'jquery-ui-core' );
		wp_enqueue_script( 'jquery-ui-autocomplete' );
	}
}


function JooviiAuspost_theme_autocomplete_js() {
	$jooviiAuspost_setting  = 	maybe_unserialize( get_option('woocommerce_jooviiauspost_settings') );
	
	if ( isset($jooviiAuspost_setting['enable_addressmatch']) && 'yes' == $jooviiAuspost_setting['enable_addressmatch'] ) 
	{
		
		// ADD CSS	
		wp_enqueue_style( 'jooviiauspost_frontend_styles', plugin_dir_url( __FILE__ ) . 'joovii-auspost-frontend-styles.css' );
		
	    $localstyle = ".jooviiAuspostCityZipLoader
						 { 
							background: url(" . esc_html(plugins_url( '', __FILE__ )) . "/loader.gif) !important; 
							background-repeat: no-repeat !important; 
							background-position: right !important; 
						 }";

		wp_add_inline_style( 'jooviiauspost_frontend_styles', $localstyle );
        
		function jooviiauspost_inline_script_one()
		{
			$admin_ajax_url = admin_url( 'admin-ajax.php' );

		?>
		<script>
				function selectElements(pagename, pagetype, ui){
					jQuery( '#'+pagename+''+pagetype+'_postcode').val( ui.item.zip);
					jQuery( '#'+pagename+''+pagetype+'_city' ).val( ui.item.city );
					if(jQuery( '#'+pagename+''+pagetype+'_country' ).val() == 'AU') {
						jQuery('#'+pagename+''+pagetype+"_state option[value='"+ui.item.statecode+"']").remove();
						jQuery("#"+pagename+""+pagetype+"_state").append("<option value='"+ui.item.statecode+"' selected >"+ui.item.statename+"</option>");
					}else{
						if(ui.item.statename != ''){
							jQuery("#"+pagename+""+pagetype+"_state option[value='"+ui.item.statecode+"']").remove();
							jQuery("#"+pagename+""+pagetype+"_state").append("<option value='"+ui.item.statecode+"' selected >"+ui.item.statename+"</option>");
						}
					}
				}

				function dynamicSource( request, response , pagename, pagetype, ) {
					jQuery.ajax({
					  url: '<?php echo esc_url($admin_ajax_url);?>',
					  dataType: "json",
					  data: {action: 'auspostjooviicityziplookup', q: request.term+'&countrycode='+jQuery( "#"+pagename+""+pagetype+"_country" ).val() },
					  success: function( data ) { response( data );}
					});
				}

				jQuery(document).ready(function($){

					// FOR OLD WORDPRESS
					// CART SHIPPING CITY
					if( jQuery( 'input[name="calc_shipping_city"]' ).length ) {
						jQuery( 'input[name="calc_shipping_city"]' ).autocomplete({
								source: function( request, response ) { dynamicSource( request, response, 'calc', '_shipping' ); },
								minLength: 2,
								search: function (e, u) {jQuery(this).addClass('jooviiAuspostCityZipLoader');},
								response: function (e, u) { jQuery(this).removeClass('jooviiAuspostCityZipLoader'); },
								open    : function(){jQuery(this).removeClass('jooviiAuspostCityZipLoader');},
								focus: function( event, ui ) {jQuery( "#calc_shipping_city" ).val(  ui.item.city ); return false; },
								select: function(event, ui) { selectElements('calc', '_shipping', ui); return false; }
						});
					}

					// CART SHIPPING POSTCODE
					if ( jQuery( 'input[name="calc_shipping_postcode"]' ).length ) {
						jQuery( 'input[name="calc_shipping_postcode"]' ).autocomplete({
							source: function( request, response ) { dynamicSource( request, response, 'calc', '_shipping' ); },
							minLength: 2,
							search: function (e, u) {jQuery(this).addClass('jooviiAuspostCityZipLoader');},
							response: function (e, u) { jQuery(this).removeClass('jooviiAuspostCityZipLoader'); },
							open    : function(){jQuery(this).removeClass('jooviiAuspostCityZipLoader');},
							focus: function( event, ui ) {jQuery( "#calc_shipping_postcode" ).val(  ui.item.city ); return false; },
							select: function(event, ui) { selectElements('calc', '_shipping', ui); return false; }
						});
					}

					// CHECKOUT billing POSTCODE
					if( jQuery( 'input[name="billing_postcode"]' ).length ) {
						jQuery( 'input[name="billing_postcode"]' ).autocomplete({
							source: function( request, response ) { dynamicSource( request, response, '', 'billing' ); },
							minLength: 2,
							search: function (e, u) {jQuery(this).addClass('jooviiAuspostCityZipLoader');},
							response: function (e, u) { jQuery(this).removeClass('jooviiAuspostCityZipLoader'); },
							open    : function(){jQuery(this).removeClass('jooviiAuspostCityZipLoader');},
							focus: function( event, ui ) {jQuery( "#billing_postcode" ).val(  ui.item.city ); return false; },
							select: function(event, ui) { selectElements('', 'billing', ui); jQuery('body').trigger('update_checkout'); return false; }
						});
					}
					// CHECKOUT --------------------------------------------------------------------------------```````````````````-----------------`
					if( jQuery( 'input[name="billing_city"]' ).length ) {
						jQuery( 'input[name="billing_city"]' ).autocomplete({
							source: function( request, response ) { dynamicSource( request, response, '', 'billing' ); },
							minLength: 2,
							search: function (e, u) {jQuery(this).addClass('jooviiAuspostCityZipLoader');},
							response: function (e, u) { jQuery(this).removeClass('jooviiAuspostCityZipLoader'); },
							open    : function(){jQuery(this).removeClass('jooviiAuspostCityZipLoader');},
							focus: function( event, ui ) {jQuery( "#billing_city" ).val(  ui.item.city ); return false; },
							select: function(event, ui) { selectElements('', 'billing', ui); jQuery('body').trigger('update_checkout'); return false; }
						});
					}

					// ----- checkout shipping
					// SHIPPING POSTCODE
					if( jQuery( 'input[name="shipping_postcode"]' ).length ) {
						jQuery( 'input[name="shipping_postcode"]' ).autocomplete({
							source: function( request, response ) { dynamicSource( request, response, '', 'shipping' ); },
							minLength: 2,
							search: function (e, u) {jQuery(this).addClass('jooviiAuspostCityZipLoader');},
							response: function (e, u) { jQuery(this).removeClass('jooviiAuspostCityZipLoader'); },
							open    : function(){jQuery(this).removeClass('jooviiAuspostCityZipLoader');},
							focus: function( event, ui ) {jQuery( "#shipping_postcode" ).val(  ui.item.city ); return false; },
							select: function(event, ui) { selectElements('', 'shipping', ui); jQuery('body').trigger('update_checkout'); return false; }
						});
					}

					if( jQuery( 'input[name="shipping_city"]' ).length ) {
						jQuery( 'input[name="shipping_city"]' ).autocomplete({
							source: function( request, response ) { dynamicSource( request, response, '', 'shipping' ); },
							minLength: 2,
							search: function (e, u) {jQuery(this).addClass('jooviiAuspostCityZipLoader');},
							response: function (e, u) { jQuery(this).removeClass('jooviiAuspostCityZipLoader'); },
							open    : function(){jQuery(this).removeClass('jooviiAuspostCityZipLoader');},
							focus: function( event, ui ) {jQuery( "#shipping_city" ).val(  ui.item.city ); return false; },
							select: function(event, ui) { selectElements('', 'shipping', ui); jQuery('body').trigger('update_checkout'); return false; }
						});
					}

					//// FOR NEW WORDPRESS VERSIONS ///////////////////////////////
					var cart_city = jQuery(".wc-block-components-address-form__city input");
					console.log( ".wc-block-components-address-form__city input" );
					//if( cart_city.length ) {
						console.log( ".wc-block-components-address-form__city input length" );
						jQuery( cart_city[0] ).autocomplete({
								source: function( request, response ) { dynamicSource( request, response, 'calc', '_shipping' ); },
								minLength: 2,
								search: function (e, u) {jQuery(this).addClass('jooviiAuspostCityZipLoader');},
								response: function (e, u) { jQuery(this).removeClass('jooviiAuspostCityZipLoader'); },
								open    : function(){jQuery(this).removeClass('jooviiAuspostCityZipLoader');},
								focus: function( event, ui ) {jQuery( cart_city[0] ).val(  ui.item.city ); return false; },
								select: function(event, ui) { selectElements('calc', '_shipping', ui); return false; }
						});
					//}

					// CART SHIPPING POSTCODE
					var cart_postcode = jQuery(".wc-block-components-address-form__postcode input");
					if ( cart_postcode.length ) {
						jQuery( 'input[name="calc_shipping_postcode"]' ).autocomplete({
							source: function( request, response ) { dynamicSource( request, response, 'calc', '_shipping' ); },
							minLength: 2,
							search: function (e, u) {jQuery(this).addClass('jooviiAuspostCityZipLoader');},
							response: function (e, u) { jQuery(this).removeClass('jooviiAuspostCityZipLoader'); },
							open    : function(){jQuery(this).removeClass('jooviiAuspostCityZipLoader');},
							focus: function( event, ui ) {jQuery( cart_postcode[0] ).val(  ui.item.city ); return false; },
							select: function(event, ui) { selectElements('calc', '_shipping', ui); return false; }
						});
					}

					// ----- CHECKOUT FIELDS
					// Billing CITY
					if( jQuery( 'input#billing-city' ).length ){
						jQuery( 'input#billing-city"]' ).autocomplete({
							source: function( request, response ) { dynamicSource( request, response, '', 'billing' ); },
							minLength: 2,
							search: function (e, u) {jQuery(this).addClass('jooviiAuspostCityZipLoader');},
							response: function (e, u) { jQuery(this).removeClass('jooviiAuspostCityZipLoader'); },
							open    : function(){jQuery(this).removeClass('jooviiAuspostCityZipLoader');},
							focus: function( event, ui ) {jQuery( "input#billing-city" ).val(  ui.item.city ); return false; },
							select: function(event, ui) { selectElements('', 'billing', ui); jQuery('body').trigger('update_checkout'); return false; }
						});
					}
					// billing POSTCODE
					if( jQuery( 'input#billing-postcode' ).length ){
						jQuery( 'input#billing-postcode' ).autocomplete({
							source: function( request, response ) { dynamicSource( request, response, '', 'billing' ); },
							minLength: 2,
							search: function (e, u) {jQuery(this).addClass('jooviiAuspostCityZipLoader');},
							response: function (e, u) { jQuery(this).removeClass('jooviiAuspostCityZipLoader'); },
							open    : function(){jQuery(this).removeClass('jooviiAuspostCityZipLoader');},
							focus: function( event, ui ) {jQuery( 'input#billing-postcode' ).val(  ui.item.city ); return false; },
							select: function(event, ui) { selectElements('', 'billing', ui); jQuery('body').trigger('update_checkout'); return false; }
						});
					}


					// ----- checkout shipping
					// SHIPPING CITY
					if( jQuery( 'input#shipping-city' ).length ){
						jQuery( 'input#shipping-city' ).autocomplete({
							source: function( request, response ) { dynamicSource( request, response, '', 'shipping' ); },
							minLength: 2,
							search: function (e, u) {jQuery(this).addClass('jooviiAuspostCityZipLoader');},
							response: function (e, u) { jQuery(this).removeClass('jooviiAuspostCityZipLoader'); },
							open    : function(){jQuery(this).removeClass('jooviiAuspostCityZipLoader');},
							focus: function( event, ui ) {jQuery( "input#shipping-city" ).val(  ui.item.city ); return false; },
							select: function(event, ui) { selectElements('', 'shipping', ui); jQuery('body').trigger('update_checkout'); return false; }
						});
					}

					// SHIPPING POSTCODE
					if( jQuery( 'input#shipping-postcode' ).length ){
						jQuery( 'input#shipping-postcode' ).autocomplete({
							source: function( request, response ) { dynamicSource( request, response, '', 'shipping' ); },
							minLength: 2,
							search: function (e, u) {jQuery(this).addClass('jooviiAuspostCityZipLoader');},
							response: function (e, u) { jQuery(this).removeClass('jooviiAuspostCityZipLoader'); },
							open    : function(){jQuery(this).removeClass('jooviiAuspostCityZipLoader');},
							focus: function( event, ui ) {jQuery( 'input#shipping-postcode' ).val(  ui.item.city ); return false; },
							select: function(event, ui) { selectElements('', 'shipping', ui); jQuery('body').trigger('update_checkout'); return false; }
						});
					}
				});
		</script>
		<?php
		}
		
		// ADD INLINE JS
		wp_register_script( 'jooviiauspost_frontend_checkout_script', '' );
		wp_enqueue_script( 'jooviiauspost_frontend_checkout_script' );
		wp_add_inline_script( 'jooviiauspost_frontend_checkout_script', jooviiauspost_inline_script_one() );
	}
}

/**
* This function adds shipping rates at checkout.
*
* @internal
*
* @return array
*/
function JooviiAuspost_add_shipping_zone_method( $methods ) {
	$methods['jooviiauspost-zone'] = 'JooviiAuspost_Shipping_Zone_Method';
	return $methods;
}

/**
* This function adds shipping rates at checkout.
*
* @internal
*
* @return array
*/
function JooviiAuspost_Shipping_Zone_Method() {
	$assign_permission = 'customer';
	if ( !class_exists('JooviiAuspost_Shipping_Zone_Method') ) {
		class JooviiAuspost_Shipping_Zone_Method extends WC_Shipping_Method {
			/**
			* This function adds shipping rates at checkout.
			*
			*  @internal
			* @return array
			**/
			public function __construct ( $instance_id = 0 ) {
				$this->id = 'jooviiauspost-zone';
				$this->instance_id = absint( $instance_id );
				$this->method_title = __( 'JooviiAuspost', 'joovii-auspost-shipping-method' );
				$this->method_description = __( 'This app provides the ultimate connectivity between Shopify and Auspost.', 'joovii-auspost-shipping-method' );
				$this->supports = array( 'shipping-zones', 'instance-settings', 'instance-settings-modal');
				$this->init();
				$title = $this->get_option('title');
				$this->title = !empty( $title ) ? $title : __( 'JooviiAuspost Shipping', 'joovii-auspost-shipping-method' );
			}
			/**
			* * This function adds shipping rates at checkout.
			* *
			* * @internal
			* *
			* * @return array
			* */
			public function init() {
				$this->init_settings();
				add_action( 'woocommerce_update_options_shipping_' . $this->id, array( $this, 'process_admin_options' ) );
			}
			/**
			* * This function adds shipping rates at checkout.
			* *
			* * @internal
			* *
			* * @return array
			* */
			public function calculate_shipping( $package = array() ) {
				JooviiAuspost_logActions("STARTED calculate_shipping_zone");
				$weight = 0;
				$volume	= 0;
				global $woocommerce;
				$s_s = maybe_unserialize( get_option('woocommerce_jooviiauspost_settings') );


				$pickupCountry    = trim($s_s['pickup_country']);
				$pickupSuburb 	  = trim($s_s['pickup_suburb']);
				$pickupPostcode   = trim($s_s['pickup_postcode']);
				if ( empty($pickupSuburb ) || empty($pickupPostcode) ) {
					return ;
				}
				$deliveryCountry  = trim($package['destination']['country']);

				$maxWeight = JooviiAuspost_maxWeightLimit ($pickupCountry, trim($package['destination']['country']) );
				$maxVolume = JooviiAuspost_maxVolumeLimit ($pickupCountry, trim($package['destination']['country']) );
				$cartChkout=[];
				$wpWeightUnit = get_option('woocommerce_weight_unit');
				$wpDimensionUnit = get_option('woocommerce_dimension_unit');
				$cartChkout['rate']['origin'] = [
					'country' => $s_s['pickup_country'],
					'postal_code' => $s_s['pickup_postcode'],
					'province' => $s_s['sender_state'],
					'city' => $s_s['pickup_suburb'],
					'name' =>$s_s['sender_name'],
					'address1' =>$s_s['sender_address'],
					'address2' => $s_s['sender_address'],
					'address3' => $s_s['sender_address'],
					'latitude' =>'', 'longitude' =>'',
					'phone' =>$s_s['sender_contact_number'],
					'fax' =>$s_s['sender_contact_number'],
					'email' => get_option('admin_email'),
					'address_type' =>'',
					'company_name' =>$s_s['sender_name'] 
				];
				$c_d= WC()->session->get('customer');
				$cartChkout['rate']['destination'] = 
				[
					'country' => isset($c_d['shipping_country']) ? $c_d['shipping_country'] : '',
					'postal_code' => isset($c_d['shipping_postcode']) ? $c_d['shipping_postcode'] : '',
					'province' => isset($c_d['shipping_state']) ? $c_d['shipping_state'] : '',
					'city' => isset($c_d['shipping_city']) ? $c_d['shipping_city'] : '',
					'name' => isset($c_d['shipping_first_name']) ? $c_d['shipping_first_name'] : '',
					'address1' => isset($c_d['shipping_address']) ? $c_d['shipping_address'] : '',
					'address2' => isset($c_d['shipping_address_1']) ? $c_d['shipping_address_1'] : '',
					'address3' => isset($c_d['shipping_address_2']) ? $c_d['shipping_address_2'] : '',
					'latitude' => '', 
					'longitude' =>'',
					'phone' => isset($c_d['shipping_phone']) ? $c_d['shipping_phone'] : '',
					'fax'   => isset($c_d['shipping_phone']) ? $c_d['shipping_phone'] : '',
					'email' => isset($c_d['email']) ? $c_d['email'] : '' ,
					'address_type' => '',
					'company_name' => isset($c_d['shipping_company']) ? $c_d['shipping_company'] : '' 
				];
				
				$items = $woocommerce->cart->get_cart();
				$packageArr = array();
				$cartTotalQuatity = 0;
				$cartTotalweight = 0;
				foreach ( $package['contents'] as $item_id => $values ) {
					//foreach ( $items as $item_id => $values ) {
					//JooviiAuspost_logActions(" cart-p :".$item_id.": ". print_r($values,true) );
					$_product = $values['data'];
					$weightP = JooviiAuspost_getWeight ( $_product->get_weight(), $pickupCountry );
					$weight = $weight + $weightP * $values['quantity'];
					$cartTotalQuatity = $cartTotalQuatity + $values['quantity'];
					if ( $_product->get_weight()>0 ) {
						$cartTotalweight = $cartTotalweight + ( $_product->get_weight() * $values['quantity'] );
					}
					JooviiAuspost_logActions(' get_weight/weight [1] : ' . $_product->get_weight() . '--' . $weightP );
					JooviiAuspost_logActions(' quantity/weight [2] : ' . $values['quantity'] );
					JooviiAuspost_logActions(' weight/weight [3] : ' . $weight );
					$volumeP = 0;
					if ( isset($s_s['volume_param']) && 'yes' == trim($s_s['volume_param']) ) {
						if ( $_product->get_length() >0 ) {
							$volumnP_l = JooviiAuspost_getDimension($_product->get_length(), $pickupCountry);
						} else {
							$volumnP_l = 0;
						}
						if ( $_product->get_width() >0 ) {
							$volumnP_w = JooviiAuspost_getDimension($_product->get_width(), $pickupCountry);
						} else {
							$volumnP_w = 0;
						}
						if ( $_product->get_height() >0 ) {
							$volumnP_h = JooviiAuspost_getDimension($_product->get_height(), $pickupCountry);
						} else {
							$volumnP_h = 0;
						}
						$volumeP = ( ( $volumnP_l * $volumnP_w * $volumnP_h ) );
						$volume += ( $volumeP * $values['quantity'] );
						JooviiAuspost_logActions( ' volume-> :: ' . $volume . ' = ' . $volumnP_l . '--' . $volumnP_w . '--' . $volumnP_h );
					}
					JooviiAuspost_logActions( ' weightP/maxWeight [3-1] : ' . $weightP . '=' . $maxWeight . '-' . $weight );
					if ( $weightP > 0 ) {
						$wt = isset($s_s['warningtext'])?$s_s['warningtext']:'';
						if ( $weightP > $maxWeight ) {
							if ( isset($s_s['warningtext_enable']) && 'yes' == $s_s['warningtext_enable']  ) {
								wc_add_notice(  __( 'Weight Exceeds Max Allowed Weight', 'joovii-auspost-shipping-method' ) );
							}
							return;
						}
						if ( $volumeP >0 ) {
							if ( $volumeP > $maxVolume ) {
								if ( isset($s_s['warningtext_enable']) && 'yes' == $s_s['warningtext_enable'] ) {
									wc_add_notice(  __( 'Volume Exceeds Max Allowed Volume', 'joovii-auspost-shipping-method' ) );
								}
								return;
							}
						}
						for ($i=1; $i<=$values['quantity']; $i++ ) {
							$packageArr[] = array('w' => JooviiAuspost_getWeight ($_product->get_weight(), $pickupCountry ), 'v' => $volumeP);
						}
					} else {
						if ( isset($s_s['warningtext_enable']) && 'yes' == $s_s['warningtext_enable'] ) {
							wc_add_notice(  __( 'Weight is lesser than 0', 'joovii-auspost-shipping-method' ) );
						}
						return;
					}
					//--------------------------------------------------------------------
					$weightP = JooviiAuspost_getWeight( $_product->get_weight(), $pickupCountry );
					if ( 'kg' == $wpWeightUnit ) {
						$weight = $weightP * 1000;
					} elseif ('lbs' == $wpWeightUnit ) {
						$weight = $weightP * 453.6;
					} else {
						$weight= $weightP * 1000;
					}
					if ( $_product->get_length() >0 ) {
						$volumnP_l = JooviiAuspost_getDimension($_product->get_length(), $pickupCountry);
						if ( 'm' ==$wpDimensionUnit ) {
							$l=$volumnP_l*100;
						} elseif ('in' == $wpDimensionUnit ) {
							$l=$volumnP_l*2.54;
						} elseif ( 'ft' == $wpDimensionUnit ) {
							$l=$volumnP_l*30.48;
						} else {
							$l=$volumnP_l*100;
						}
					} else {
						$l=5;
					}
					if ( $_product->get_width() >0 ) {
						$volumnP_w = JooviiAuspost_getDimension($_product->get_width(), $pickupCountry);
						if ( 'm' == $wpDimensionUnit ) {
							$w=$volumnP_w*100;
						} elseif ( 'in' == $wpDimensionUnit ) {
							$w=$volumnP_w*2.54;
						} elseif ( 'ft' == $wpDimensionUnit ) {
							$w=$volumnP_w*30.48;
						} else {
							$w=$volumnP_w*100;
						}
					} else {
						$w=5;
					}
					if ( $_product->get_height() >0 ) {
						$volumnP_h = JooviiAuspost_getDimension( $_product->get_height(), $pickupCountry );
						if ( 'm' == $wpDimensionUnit ) {
							$h=$volumnP_h*100;
						} elseif ( 'in' == $wpDimensionUnit ) {
							$h=$volumnP_h*2.54;
						} elseif ( 'ft' == $wpDimensionUnit ) {
							$h=$volumnP_h*30.48;
						} else {
							$h=$volumnP_h*100;
						}
					} else {
						$h=5;
					}
					if ( '0' == $_product->get_parent_id() ) {
						$cartChkout['rate']['items'][] = array( 'name' => $_product->get_name(), 'sku' => $_product->get_sku(), 'quantity' => $values['quantity'], 'grams' =>$weight, 'dimension' => array('l' => $l, 'w' =>$w, 'h' =>$h), 'price' => $_product->get_price(), 'vendor' => '', 'requires_shipping' => $_product->get_shipping_class_id(), 'taxable' => $_product->get_tax_status(), 'fulfillment_service' => '', 'properties' => array(), 'product_id' => $_product->get_id(), 'variant_id' => $_product->get_id() );
					} else {
						$cartChkout['rate']['items'][] = array( 'name' => $_product->get_name(), 'sku' => $_product->get_sku(), 'quantity' => $values['quantity'], 'grams' =>$weight, 'dimension' => array('l' => $l,'w' =>$w,'h' =>$h), 'price' => $_product->get_price(), 'vendor' => '', 'requires_shipping' => $_product->get_shipping_class_id(), 'taxable' => $_product->get_tax_status(), 'fulfillment_service' => '', 'properties' => array(), 'product_id' => $_product->get_parent_id(), 'variant_id' => $_product->get_id() );
					}
				}
				JooviiAuspost_logActions(' cartChkout data Arr 1 : ' . print_r($cartChkout, true) );
				$cartfetch=json_encode($cartChkout);
				JooviiAuspost_logActions(' cartChkout data Arr 2 : ' . print_r(['datapick'=>$cartfetch], true) );
				$st = maybe_unserialize( get_option('woocommerce_jooviiauspost_settings') );
				$shop_id = isset($st['shop_id']) ? $st['shop_id'] : '';
				$securitycode = isset($st['accesstoken']) ? $st['accesstoken'] : '';
				$url =   '/getwebapquote?shop=x&shopid=' . $shop_id . '&securitycode=' . $securitycode;
				JooviiAuspost_logActions(' Cart/Checkout calling API url to fetch RATES : ' . $url );
				$cartfetch_data = ['datapick'=>$cartfetch];
				$response = JooviiAuspost_makeapicall($url, $cartfetch_data);
				JooviiAuspost_logActions(' webapp--response: ' . $response );
				$result = json_decode($response, true);
				$q=1;
				$result_rate = [];
				JooviiAuspost_logActions(' cartChkout data Arr 3 : ' . print_r($result, true) );
				if ( isset($result['rates']) ) {
					JooviiAuspost_logActions('Adding Rates to Cart');
					foreach ( $result['rates'] as $value ) {
						$result_rate = [];
						$result_rate[0]['quote']['gross']['amount'] = ( $value['total_price']/100 );
						$result_rate[0]['quote']['net']['amount'] = ( $value['net_price']/100 );
						$result_rate[0]['quote']['tax']['amount'] = ( $value['tax_price']/100 ) ;
						$result_rate[0]['plan_name'] = $value['service_name'];
						$rate = JooviiAuspost_createRateArray ($package, $s_s, $result_rate );
						$this->add_rate($rate);
						$q++;
					}
				}
			}
		}
	}
}

function JooviiAuspost_getcityziplookup () {
  $input =  ( isset ($_REQUEST['q']) ? sanitize_text_field( wp_unslash($_REQUEST['q'])) : '' );
  $inputArr = explode('countrycode', $input);
  $placename_startsWith = $inputArr[0];
  $country=$inputArr[1];
  $url = 'http://api.geonames.org/postalCodeSearchJSON?placename_startsWith=' . $placename_startsWith . '&maxRows=400&country=' . $country . '&username=nerdster';
  $url = str_replace(' ', '%20', $url);
  $suggestions1 = wp_remote_get($url);
  $suggestions2 = json_decode(wp_remote_retrieve_body($suggestions1), true);
	$json = '';
	foreach ( $suggestions2['postalCodes'] as $k => $v ) {
		$json .= '{"ID":' . ( $k + 1 ) . ',"label":"' . $v['placeName'] . ', ' . $v['postalCode'] . ' ' . $v['adminName1'] . ' ' . $country . '","city":"' . $v['placeName'] . '","zip":"';
		$json .=  $v['postalCode'] . '","statecode":"' . trim( $v['ISO3166-2'] ) . '","statename":"' . trim($v['adminName1']) . '"},';
	}
	$json = rtrim($json, ',');
	$json = '[' . $json . ']';
	echo esc_html ( $json );
	die();
}
