<?php
/**
 * This file Updates Shipment against Orders
 *
 * @package Officialauspostshippingmethod
 *
 * @link https://joovii.com
 *
 * PHP version : 7.2.1
 */

function jooviiauspost_shipment_update()
{
    $data = [];
	
	if( isset($_REQUEST) && is_array($_REQUEST) )
	{
		foreach($_REQUEST as $key=>$value)
		{
		   	$data[$key] = sanitize_text_field($value);
		}
	}
 
	if ( isset($data['order_id']) && ''!=$data['order_id']) {
		
		JooviiAuspost_shipment_update_log("Shipment-update Step 1");
		
		$security_code = $data['security_code'];
		
		$st = maybe_unserialize(get_option('woocommerce_jooviiauspost_settings'));
		
		/*
		if (is_array($st) && count($st) ) {
			if (isset($st['accesstoken']) && ''!=$st['accesstoken']) {
				if (md5($security_code)!=$st['accesstoken']) {
					JooviiAuspost_retMsg(101, 'Access Token Mismatch');
				}
			} else {
				JooviiAuspost_retMsg(102, 'Access Token Missing in Woo Store');
			}
		} else {
			JooviiAuspost_retMsg(103, 'Access Token Missing in Woo Store');
		}
		*/

		JooviiAuspost_shipment_update_log(print_r($data, true));
		$hpos_enabled = 0;

		if (class_exists(\Automattic\WooCommerce\Utilities\OrderUtil::class) ) {
			if (\Automattic\WooCommerce\Utilities\OrderUtil::custom_orders_table_usage_is_enabled() ) {
				$hpos_enabled  = 1;
			}
		}
		
		$order_id = $data['order_id'];
		if ($hpos_enabled) {
			$orderitem = wc_get_order($order_id);
			if ($orderitem ) {
				
				$receiver_email   = $orderitem->get_meta('_billing_email');
				$receiver_name    = $orderitem->get_meta('_shipping_first_name') . ' ' .
									$orderitem->get_meta('_shipping_last_name');
				
				if (isset($data['shipment_order_id'])) {
					$orderitem->update_meta_data('jooviiauspost_order_id', $data['shipment_order_id']);
				}
				
				if (isset($data['shipment_post'])) {
					$orderitem->update_meta_data('jooviiauspost_post', $data['shipment_post']);
				}
				
				if (isset($data['shipment_reference'])) {
					$orderitem->update_meta_data('jooviiauspost_reference', $data['shipment_reference']);
				}
				
				if (isset($data['shipment_response'])) {
					$orderitem->update_meta_data('jooviiauspost_response', $data['shipment_response']);
				}
				
				if (isset($data['shipment_tracking_url'])) {
					$orderitem->update_meta_data('jooviiauspost_tracking_url', $data['shipment_tracking_url']);
				}
				
				if (isset($data['label_url'])) {
					$orderitem->update_meta_data('jooviiauspost_label_url', $data['label_url']);
				}
				
				$orderitem->save();
				
				if (isset($data['shipment_response'])) {
					$jooviiAuspost_response = json_decode(stripslashes($data['shipment_response']), true);
					jooviiauspost_send_tracking_email($order_id, $receiver_email, $receiver_name, $jooviiAuspost_response);
				}
				JooviiAuspost_retMsg(0, 'Order Updated');
			} else {
				JooviiAuspost_retMsg(104, 'Order Not Found');
			}
		} else {
			$orderitem = get_post($order_id);
			if ($orderitem) {
				JooviiAuspost_shipment_update_log("Shipment-update Step 3");
				$receiver_email = get_post_meta($order_id, '_billing_email', true);
				$receiver_name  = get_post_meta($order_id, '_shipping_first_name', true)
								. ' ' . get_post_meta($order_id, '_shipping_last_name', true);

				if (isset($data['shipment_order_id'])) {
					update_post_meta($order_id, 'jooviiauspost_order_id', $data['shipment_order_id']);
				}
				if (isset($data['shipment_post'])) {
					update_post_meta($order_id, 'jooviiauspost_post', $data['shipment_post']);
				}
				if (isset($data['shipment_reference'])) {
					update_post_meta($order_id, 'jooviiauspost_reference', $data['shipment_reference']);
				}
				if (isset($data['shipment_response'])) {
					update_post_meta($order_id, 'jooviiauspost_response', $data['shipment_response']);
				}
				if (isset($data['shipment_tracking_url'])) {
					update_post_meta($order_id, 'jooviiauspost_tracking_url', $data['shipment_tracking_url']);
				}
				if (isset($data['label_url'])) {
					update_post_meta($order_id, 'jooviiauspost_label_url', $data['label_url']);
				}

				JooviiAuspost_shipment_update_log('Shipment Details Updated', $order_id);
				if (isset($data['shipment_response'])) {
					$jooviiAuspost_response = json_decode(stripslashes($data['shipment_response']), true);
					jooviiauspost_send_tracking_email($order_id, $receiver_email, $receiver_name, $jooviiAuspost_response);
				}

				JooviiAuspost_retMsg(0, 'Order Updated ....');
			} else {
				JooviiAuspost_retMsg(105, 'Order Not Found');
			}
		}
	} else {
		JooviiAuspost_retMsg(106, '-Unauthorized-'); 
	}
}

/**
 * This function sends tracking emails
 *
 * @param Integer $order_id
 *
 * @param  String $receiver_email
 *
 * @param  String $receiver_name
 *
 * @param $response
 *
 * @return void
 */
function jooviiauspost_send_tracking_email($order_id, $receiver_email, $receiver_name, $response ) {

	$site_url = home_url();
	$jooviiAuspost_setting = maybe_unserialize(get_option('woocommerce_jooviiauspost_settings'));

	if ('yes'==$jooviiAuspost_setting['tracking_email']) {
		$default_emailTemplateVal = '
		Hi {{customer_name}}
		An order you recently placed on our website has had its status changed.

		The status of order #{{order_no}} is now Shipped

		Shipment Tracking Numbers: {{tracking_number}}
		Shipment Tracking Links : {{tracking_link}}

		{{store_name}}';

		$to = $receiver_email;
		$subject = 'Your Order Has Been Updated (#' . $order_id . ')';
		$emailTemplateVal = get_option('jooviiauspost_woocommerce_tracking_email_template');
		if ('' == trim($emailTemplateVal)) {
			$emailTemplateVal = $default_emailTemplateVal;
		}
		$body = str_replace('{{customer_name}}', ucwords($receiver_name), $emailTemplateVal);
		$body = str_replace('{{order_no}}', $order_id, $body);
		$body = str_replace('{{tracking_number}}', $response['shipment_reference'], $body);
		$body = str_replace('{{tracking_link}}', $response['shipment_tracking_url'], $body);
		$body = nl2br($body);
		$body = str_replace('{{store_name}}', $site_url, $body);

		$site_title = get_bloginfo('name');
		$site_admin_email = get_bloginfo('admin_email');


		$headers = array('Content-Type: text/html; charset=UTF-8');
		$headers[] = 'From: ' . $site_title . '<' . $site_admin_email . '>';

		wp_mail($to, $subject, $body, $headers);

		JooviiAuspost_shipment_update_log(' tracking email sent [' . $to . ']  :: ' . $order_id, $order_id);
		JooviiAuspost_shipment_update_log(' tracking email sent [subject] :: ' . $subject, $order_id);
		JooviiAuspost_shipment_update_log(' tracking email sent [body] :: ' . $body, $order_id);
		JooviiAuspost_shipment_update_log(' tracking email sent [header] :: ->' . $site_title . '--' .
									$site_admin_email . '<---', $order_id);
		JooviiAuspost_shipment_update_log(' tracking email sent [emailTemplateVal] :: ' . $emailTemplateVal, $order_id);

	}

	$orderitem = new WC_Order($order_id);
	if ('processing'==$jooviiAuspost_setting['change_order_status']) {
		$orderitem->update_status('processing');
		JooviiAuspost_shipment_update_log(' update order status to processing :: ' . $order_id, $order_id);
	}
	if ('completed'==$jooviiAuspost_setting['change_order_status']) {
		$orderitem->update_status('completed');
		JooviiAuspost_shipment_update_log(' update order status to completed :: ' . $order_id, $order_id);
	}
	//JooviiAuspost_shipment_update_log('Order submitted from ' . $jooviiAuspost_setting['book_shipment_on'].' completed.' .$postedby, $order_id);

}

/**
 * This function Updates the LOG
 *
 * @param  String $message
 *
 * @param  Integer $order_id
 *
 * @return void
 */
function JooviiAuspost_shipment_update_log($message, $orderid = '0') {
	$jooviiAuspost_setting = maybe_unserialize(get_option('woocommerce_jooviiauspost_settings'));
	if ('yes'==$jooviiAuspost_setting['enable_log']) {
		global $wpdb;
		$table_name = $wpdb->prefix . 'jooviiauspost_logs';
		$wp_timezone = get_option('timezone_string');
		$wp_timezone = ( ''==$wp_timezone?'Australia/Sydney':$wp_timezone );
		$tz = new DateTimeZone($wp_timezone);
		$currentDateTime = new DateTime('now', $tz);
		$date = $currentDateTime->format('Y-m-d H:i:s');
		$wpdb->insert($table_name, array(
						'eventname'=>'null', 
						'orderid'=>$orderid,
						'logs'=>$message, 
						'timestamp'=> $date), 
						array('%s', '%d', '%s'));
	}
}


